diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index 98420cb89..4fc96cded 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -13,23 +13,22 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T>
-{
+public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T> {
 
-    public ItemBlockAlgae(Block<T> block)
-    {
+    public ItemBlockAlgae(Block<T> block) {
         super(block);
         setMaxDamage(0);
         setHasSubtypes(true);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         return false;
     }
 
@@ -37,21 +36,21 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T>
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         double reachDistance = player.getGamemode().getBlockReachDistance();
         HitResult rayCast = player.rayCast(reachDistance, 1f, true, false, false);
-        if(rayCast == null) {
+        if (rayCast == null) {
             return selfStack;
         }
-        if(rayCast instanceof HitResult.Tile hitTile) {
+        if (rayCast instanceof HitResult.Tile hitTile) {
             TilePos blockPos = new TilePos(hitTile.tilePos);
-            if(world.getBlockId(blockPos) == Blocks.FLUID_WATER_STILL.id()) {
+            if (world.getBlockId(blockPos) == Blocks.FLUID_WATER_STILL.id()) {
                 blockPos.y++;
             } else {
                 return selfStack;
             }
 
-            if(world.getBlockId(blockPos) != 0) {
+            if (world.getBlockId(blockPos) != 0) {
                 return selfStack;
             }
-            if(selfStack.consumeItem(player) && world.setBlockIdDataNotify(blockPos, this.block.id(), 0)) {
+            if (selfStack.consumeItem(player) && world.setBlockIdDataNotify(blockPos, this.block.id(), 0)) {
                 this.block.onPlacedByMob(world, blockPos, Side.NONE, player, 0.5, 0.5);
                 world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 player.swingItem();
@@ -61,9 +60,9 @@ public class ItemBlockAlgae<T extends BlockLogic> extends ItemBlock<T>
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction);
-        TilePos up = blockPos.up();
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        TilePos up = blockPos.up(new TilePos());
         Block<?> b = world.getBlock(blockPos);
         Block<?> bAbove = world.getBlock(up);
         if (b == Blocks.FLUID_WATER_STILL && (bAbove == null || bAbove.hasTag(BlockTags.PLACE_OVERWRITES))) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index b90fe2099..a93cc2f38 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -8,66 +8,67 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemBlockLadder<T extends BlockLogicLadder> extends ItemBlock<T> {
 
-	public ItemBlockLadder(@NotNull Block<T> block) {
-		super(block);
-	}
+    public ItemBlockLadder(@NotNull Block<T> block) {
+        super(block);
+    }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		blockPos = new TilePos(blockPos);
-		Block<?> clickedBlock = world.getBlock(blockPos);
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        TilePos bp = new TilePos(blockPos);
+        Block<?> clickedBlock = world.getBlock(bp);
 
-		BlockLogicLadder ladder = this.block.getLogic();
+        BlockLogicLadder ladder = this.block.getLogic();
 
-		if(clickedBlock == this.block && player != null && !player.isSneaking()) {
-			Side clickedLadderSide = ladder.getSideFromMeta(world.getBlockData(blockPos));
-			while(world.getBlock(blockPos) == this.block && ladder.getSideFromMeta(world.getBlockData(blockPos)) == clickedLadderSide) blockPos.y--;
-			int meta = ladder.getMetaForSide(clickedLadderSide);
-			if(ladder.canExistAt(world, new TilePos(blockPos), meta)) {
-				return placeBlock(selfStack, world, blockPos, meta, player, clickedLadderSide, 0.5, 0.5);
-			}
+        if (clickedBlock == this.block && player != null && !player.isSneaking()) {
+            Side clickedLadderSide = ladder.getSideFromMeta(world.getBlockData(bp));
+            while (world.getBlock(bp) == this.block && ladder.getSideFromMeta(world.getBlockData(bp)) == clickedLadderSide)
+                bp.y--;
+            int meta = ladder.getMetaForSide(clickedLadderSide);
+            if (ladder.canExistAt(world, new TilePos(bp), meta)) {
+                return placeBlock(selfStack, world, bp, meta, player, clickedLadderSide, 0.5, 0.5);
+            }
 
-			return false;
-		}
+            return false;
+        }
 
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(side.getDirection());
-		}
+        if (!world.canPlaceInsideBlock(bp)) {
+            bp = bp.add(side.getDirection(), new TilePos());
+        }
 
-		Side sideForPlacement = ladder.getSideForPlacement(world, blockPos, side);
-		if(sideForPlacement == null) {
-			return false;
-		}
+        Side sideForPlacement = ladder.getSideForPlacement(world, bp, side);
+        if (sideForPlacement == null) {
+            return false;
+        }
 
-		int meta = ladder.getMetaForSide(sideForPlacement);
-		if(ladder.canExistAt(world, blockPos, meta)) {
-			return placeBlock(selfStack, world, blockPos, meta, player, sideForPlacement, xHit, yHit);
-		}
+        int meta = ladder.getMetaForSide(sideForPlacement);
+        if (ladder.canExistAt(world, bp, meta)) {
+            return placeBlock(selfStack, world, bp, meta, player, sideForPlacement, xHit, yHit);
+        }
 
-		return false;
-	}
+        return false;
+    }
 
 
-	public boolean placeBlock(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TilePos blockPos, int meta, @Nullable Player player, @NotNull Side side, double xHit, double yHit) {
-		if(world.canPlaceInsideBlock(blockPos) && world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-			if(world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
+    public boolean placeBlock(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TilePos blockPos, int meta, @Nullable Player player, @NotNull Side side, double xHit, double yHit) {
+        if (world.canPlaceInsideBlock(blockPos) && world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
+            if (world.setBlockIdDataNotify(blockPos, this.block.id(), meta)) {
                 if (player == null) {
-					this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-				} else {
-					this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-				}
-				world.playBlockSoundEffect(player, blockPos.x + 0.5f, blockPos.y + 0.5f, blockPos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
-				return true;
-			}
-		}
-		return false;
-	}
-	
-	
+                    this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+                } else {
+                    this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+                }
+                world.playBlockSoundEffect(player, blockPos.x + 0.5f, blockPos.y + 0.5f, blockPos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
+                return true;
+            }
+        }
+        return false;
+    }
+
 
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
index ebc5f7fad..979738bf1 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -21,7 +21,7 @@ public class ItemBlockLamp<T extends BlockLogic> extends ItemBlock<T>
     }
     
     @Override
-    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
     	return selfStack.getMetadata();
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index f6b8d0d7f..1f4d42ba5 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -7,104 +7,103 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 
-public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T>
-{
-	public ItemBlockLayer(@NotNull Block<T> block)
-	{
-		super(block);
-	}
+public class ItemBlockLayer<T extends BlockLogicLayerBase> extends ItemBlock<T> {
+    public ItemBlockLayer(@NotNull Block<T> block) {
+        super(block);
+    }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		Block<?> targetBlock = world.getBlock(blockPos);
-		int meta = world.getBlockData(blockPos);
-		if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
-			targetBlock = null;
-			meta = 0;
-		}
-        if (selfStack.stackSize <= 0 || blockPos.y == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        Block<?> targetBlock = world.getBlock(blockPos);
+        int meta = world.getBlockData(blockPos);
+        if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
+            targetBlock = null;
+            meta = 0;
+        }
+        if (selfStack.stackSize <= 0 || blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
             return false;
         }
 
         // Check if we're placing "inside" a layer
-		if (targetBlock == this.block && side == Side.TOP) {
-			final BlockLogicLayerBase blockLayer = this.block.getLogic();
-			final int newMeta = meta + 1;
+        if (targetBlock == this.block && side == Side.TOP) {
+            final BlockLogicLayerBase blockLayer = this.block.getLogic();
+            final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + (2 * (newMeta + 1)) / 16.0f, blockPos.z + 1f);
-			if (!world.checkIfAABBIsClear(bbBox)) {
-				return false;
-			}
+            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            if (!world.checkIfAABBIsClear(bbBox)) {
+                return false;
+            }
 
-			if (newMeta < 7) {
-				world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
-			} else {
-				if (blockLayer.fullBlock != null) {
-					world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
-				} else {
-					world.setBlockIdDataNotify(blockPos.up(), this.block.id(), 0);
-				}
-			}
-			world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-			selfStack.consumeItem(player);
-			return true;
+            if (newMeta < 7) {
+                world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
+            } else {
+                if (blockLayer.fullBlock != null) {
+                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
+                } else {
+                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), 0);
+                }
+            }
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            selfStack.consumeItem(player);
+            return true;
 
-		}
+        }
 
-		// Offset position
-		if (targetBlock != null) {
-			blockPos = blockPos.add(side.getDirection());
-			targetBlock = world.getBlock(blockPos);
-			meta = world.getBlockData(blockPos);
-		}
+        // Offset position
+        if (targetBlock != null) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            targetBlock = world.getBlock(blockPos);
+            meta = world.getBlockData(blockPos);
+        }
 
-		// Check if the block we're placing into is a layer
-		if (targetBlock == this.block) {
-			final BlockLogicLayerBase blockLayer = this.block.getLogic();
-			final int newMeta = meta + 1;
+        // Check if the block we're placing into is a layer
+        if (targetBlock == this.block) {
+            final BlockLogicLayerBase blockLayer = this.block.getLogic();
+            final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + (2 * (newMeta + 1)) / 16.0f, blockPos.z + 1f);
-			if (!world.checkIfAABBIsClear(bbBox)) {
-				return false;
-			}
+            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            if (!world.checkIfAABBIsClear(bbBox)) {
+                return false;
+            }
 
-			if (newMeta < 7) {
-				world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
-			}
-			else {
-				if (blockLayer.fullBlock != null) {
-					world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
-				} else {
-					world.setBlockIdDataNotify(blockPos.up(), this.block.id(), 0);
-				}
-			}
-			world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-			selfStack.consumeItem(player);
-			return true;
-		}
+            if (newMeta < 7) {
+                world.setBlockIdDataNotify(blockPos, this.block.id(), newMeta);
+            } else {
+                if (blockLayer.fullBlock != null) {
+                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), 0);
+                } else {
+                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), 0);
+                }
+            }
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            selfStack.consumeItem(player);
+            return true;
+        }
 
-		// Regular placement, as all else fails
-		if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
-			int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-			if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
-				if (player == null) {
+        // Regular placement, as all else fails
+        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
+            int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
+            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+                if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-				} else {
+                } else {
                     this.block.onPlacedByMob(world, blockPos, Side.NONE, player, xHit, yHit);
-				}
-				world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-				selfStack.consumeItem(player);
-				return true;
-			}
-		}
-		return false;
+                }
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                selfStack.consumeItem(player);
+                return true;
+            }
+        }
+        return false;
 
-	}
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 87fe4b0be..6398d1648 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -9,109 +9,107 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemBlock<T>
-{
-	public ItemBlockLayerLeaves(@NotNull Block<T> block)
-	{
-		super(block);
-	}
+public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemBlock<T> {
+    public ItemBlockLayerLeaves(@NotNull Block<T> block) {
+        super(block);
+    }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		Block<?> targetBlock = world.getBlock(blockPos);
-		int meta = world.getBlockData(blockPos);
-		if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
-			targetBlock = null;
-			meta = 0;
-		}
-        if (selfStack.stackSize <= 0 || blockPos.y == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        Block<?> targetBlock = world.getBlock(blockPos);
+        int meta = world.getBlockData(blockPos);
+        if (targetBlock != this.block && targetBlock != null && targetBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
+            targetBlock = null;
+            meta = 0;
+        }
+        if (selfStack.stackSize <= 0 || blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
             return false;
         }
 
         // Check if we're placing "inside" a layer
-		if (targetBlock == this.block && side == Side.TOP) {
-			final BlockLogicLayerBase blockLayer = this.block.getLogic();
-			final int newMeta = meta + 1;
+        if (targetBlock == this.block && side == Side.TOP) {
+            final BlockLogicLayerBase blockLayer = this.block.getLogic();
+            final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + (2 * (newMeta + 1)) / 16.0f, blockPos.z + 1f);
-			if (!world.checkIfAABBIsClear(bbBox)) {
-				return false;
-			}
+            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            if (!world.checkIfAABBIsClear(bbBox)) {
+                return false;
+            }
 
-			if ((newMeta & 0b00001111) < 7) {
-				world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
-			}
-			else {
-				if (blockLayer.fullBlock != null) {
-					world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
-				} else {
-					world.setBlockIdDataNotify(blockPos.up(), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
-				}
-			}
-			world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-			selfStack.consumeItem(player);
-			return true;
-		}
+            if ((newMeta & 0b00001111) < 7) {
+                world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
+            } else {
+                if (blockLayer.fullBlock != null) {
+                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
+                } else {
+                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
+                }
+            }
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            selfStack.consumeItem(player);
+            return true;
+        }
 
-		// Offset position
-		if (targetBlock != null) {
-			blockPos = blockPos.add(side.getDirection());
-			targetBlock = world.getBlock(blockPos);
-			meta = world.getBlockData(blockPos);
-		}
+        // Offset position
+        if (targetBlock != null) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            targetBlock = world.getBlock(blockPos);
+            meta = world.getBlockData(blockPos);
+        }
 
-		// Check if the block we're placing into is a layer
-		if (targetBlock == this.block) {
-			final BlockLogicLayerBase blockLayer = this.block.getLogic();
-			final int newMeta = meta + 1;
+        // Check if the block we're placing into is a layer
+        if (targetBlock == this.block) {
+            final BlockLogicLayerBase blockLayer = this.block.getLogic();
+            final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + (2 * (newMeta + 1)) / 16.0f, blockPos.z + 1f);
-			if (!world.checkIfAABBIsClear(bbBox)) {
-				return false;
-			}
+            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            if (!world.checkIfAABBIsClear(bbBox)) {
+                return false;
+            }
 
-			if ((newMeta & 0b00001111) < 7) {
-				world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
-			} else {
-				if (blockLayer.fullBlock != null) {
-					world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
-				}
-				else {
-					world.setBlockIdDataNotify(blockPos.up(), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
-				}
-			}
-			world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-			selfStack.consumeItem(player);
-			return true;
-		}
+            if ((newMeta & 0b00001111) < 7) {
+                world.setBlockIdDataNotify(blockPos, this.block.id(), BlockLogicLayerLeaves.setPermanent(newMeta, true));
+            } else {
+                if (blockLayer.fullBlock != null) {
+                    world.setBlockIdDataNotify(blockPos, blockLayer.fullBlock.id(), BlockLogicLeavesBase.setPermanent(0, true));
+                } else {
+                    world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.block.id(), BlockLogicLayerLeaves.setPermanent(0, true));
+                }
+            }
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+            selfStack.consumeItem(player);
+            return true;
+        }
 
-		// Regular placement, as all else fails
-		if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
-			int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-			if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
-				if (player == null) {
+        // Regular placement, as all else fails
+        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
+            int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
+            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+                if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-				} else {
+                } else {
                     this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-				}
-				world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
-				selfStack.consumeItem(player);
-				return true;
-			}
-		}
-		return false;
+                }
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                selfStack.consumeItem(player);
+                return true;
+            }
+        }
+        return false;
 
-	}
+    }
 
-	@Override
-	public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		return BlockLogicLayerLeaves.MASK_PERMANENT;
-	}
+    @Override
+    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        return BlockLogicLayerLeaves.MASK_PERMANENT;
+    }
 
 }
